/* $Id: preview.h,v 1.3 2000/06/19 06:16:16 acapnotic Exp $ */

#ifndef _PREVIEW_H_
#define _PREVIEW_H_

#include <gtk/gtk.h>
#include <libgimpwidgets/gimpwidgets.h>
#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>
#ifndef _GLACE_H_
#  include "glace.h"
#endif

GlaceGimpPreview* ace_preview_new(GlaceGimpData* const wData);

void ace_preview_update(Glace_ClientData* const clientData);

void ace_preview_update_finished(GlaceGimpPreview* const preview);

void ace_preview_cancel(GlaceGimpPreview* const preview);

void ace_preview_progress_update(const GlaceGimpPreview* const preview,
				 const gfloat percentage);

AcePreviewState ace_preview_get_state(const GlaceGimpPreview* const preview);

void ace_preview_set_state(GlaceGimpPreview* const preview, 
			   const AcePreviewState state);

void Glace_Redraw_Preview (Glace_WData wData, 
                           Glace_ImgArrays * imgArraysPtr);

struct _GlaceGimpPreview
{
  GtkWidget*         preview;
  GtkProgressBar*    pbar;
  AcePreviewState    state;
  guint16            bpp;

  guint idle_handle;
};

#define PREVIEW_WIDTH  172
#define PREVIEW_HEIGHT 172

#define PROG_INPUT_CHUNKS  1
#define PROG_OUTPUT_CHUNKS 2
#define PROG_OCHUNKS (PROG_INPUT_CHUNKS + PROG_OUTPUT_CHUNKS)

#endif /* _PREVIEW_H_ */
